Index: uspace/drv/bus/usb/ehci/ehci_batch.c
===================================================================
--- uspace/drv/bus/usb/ehci/ehci_batch.c	(revision e6d7df1e4401315d6c6d32c2319db3adb772e934)
+++ uspace/drv/bus/usb/ehci/ehci_batch.c	(revision 45cbf897eae041f9fcdb375736ef47f65e11f98b)
@@ -42,8 +42,8 @@
 #include <usb/usb.h>
 #include <usb/debug.h>
+#include <usb/host/utils/malloc32.h>
 
 #include "ehci_batch.h"
 #include "ehci_endpoint.h"
-#include "utils/malloc32.h"
 
 /* The buffer pointer list in the qTD is long enough to support a maximum
Index: uspace/drv/bus/usb/ehci/ehci_endpoint.c
===================================================================
--- uspace/drv/bus/usb/ehci/ehci_endpoint.c	(revision e6d7df1e4401315d6c6d32c2319db3adb772e934)
+++ uspace/drv/bus/usb/ehci/ehci_endpoint.c	(revision 45cbf897eae041f9fcdb375736ef47f65e11f98b)
@@ -36,6 +36,6 @@
 #include <stdlib.h>
 #include <usb/debug.h>
+#include <usb/host/utils/malloc32.h>
 
-#include "utils/malloc32.h"
 #include "ehci_endpoint.h"
 #include "hc.h"
Index: uspace/drv/bus/usb/ehci/endpoint_list.c
===================================================================
--- uspace/drv/bus/usb/ehci/endpoint_list.c	(revision e6d7df1e4401315d6c6d32c2319db3adb772e934)
+++ uspace/drv/bus/usb/ehci/endpoint_list.c	(revision 45cbf897eae041f9fcdb375736ef47f65e11f98b)
@@ -40,5 +40,4 @@
 #include <usb/debug.h>
 
-#include "utils/malloc32.h"
 #include "endpoint_list.h"
 
Index: uspace/drv/bus/usb/ehci/endpoint_list.h
===================================================================
--- uspace/drv/bus/usb/ehci/endpoint_list.h	(revision e6d7df1e4401315d6c6d32c2319db3adb772e934)
+++ uspace/drv/bus/usb/ehci/endpoint_list.h	(revision 45cbf897eae041f9fcdb375736ef47f65e11f98b)
@@ -39,8 +39,8 @@
 #include <fibril_synch.h>
 #include <sys/types.h>
+#include <usb/host/utils/malloc32.h>
 
 #include "ehci_endpoint.h"
 #include "hw_struct/queue_head.h"
-#include "utils/malloc32.h"
 
 /** Structure maintains both EHCI queue and software list of active endpoints.*/
Index: uspace/drv/bus/usb/ehci/hc.c
===================================================================
--- uspace/drv/bus/usb/ehci/hc.c	(revision e6d7df1e4401315d6c6d32c2319db3adb772e934)
+++ uspace/drv/bus/usb/ehci/hc.c	(revision 45cbf897eae041f9fcdb375736ef47f65e11f98b)
@@ -45,8 +45,7 @@
 #include <usb/debug.h>
 #include <usb/usb.h>
-
-//#include "ehci_endpoint.h"
+#include <usb/host/utils/malloc32.h>
+
 #include "ehci_batch.h"
-#include "utils/malloc32.h"
 
 #include "hc.h"
Index: uspace/drv/bus/usb/ehci/hw_struct/queue_head.h
===================================================================
--- uspace/drv/bus/usb/ehci/hw_struct/queue_head.h	(revision e6d7df1e4401315d6c6d32c2319db3adb772e934)
+++ uspace/drv/bus/usb/ehci/hw_struct/queue_head.h	(revision 45cbf897eae041f9fcdb375736ef47f65e11f98b)
@@ -38,6 +38,6 @@
 #include <sys/types.h>
 #include <usb/host/endpoint.h>
-
-#include "../utils/malloc32.h"
+#include <usb/host/utils/malloc32.h>
+
 #include "link_pointer.h"
 #include "transfer_descriptor.h"
Index: uspace/drv/bus/usb/ehci/hw_struct/transfer_descriptor.c
===================================================================
--- uspace/drv/bus/usb/ehci/hw_struct/transfer_descriptor.c	(revision e6d7df1e4401315d6c6d32c2319db3adb772e934)
+++ uspace/drv/bus/usb/ehci/hw_struct/transfer_descriptor.c	(revision 45cbf897eae041f9fcdb375736ef47f65e11f98b)
@@ -39,6 +39,6 @@
 
 #include <usb/usb.h>
+#include <usb/host/utils/malloc32.h>
 
-#include "../utils/malloc32.h"
 #include "mem_access.h"
 #include "transfer_descriptor.h"
Index: pace/drv/bus/usb/ehci/utils/malloc32.h
===================================================================
--- uspace/drv/bus/usb/ehci/utils/malloc32.h	(revision e6d7df1e4401315d6c6d32c2319db3adb772e934)
+++ 	(revision )
@@ -1,111 +1,0 @@
-/*
- * Copyright (c) 2013 Jan Vesely
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- *
- * - Redistributions of source code must retain the above copyright
- *   notice, this list of conditions and the following disclaimer.
- * - Redistributions in binary form must reproduce the above copyright
- *   notice, this list of conditions and the following disclaimer in the
- *   documentation and/or other materials provided with the distribution.
- * - The name of the author may not be used to endorse or promote products
- *   derived from this software without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
- * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
- * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
- * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
- * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
- * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
- * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
- * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
- * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
- * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
- */
-/** @addtogroup drvusbehci
- * @{
- */
-/** @file
- * @brief EHCI driver
- */
-#ifndef DRV_EHCI_UTILS_MALLOC32_H
-#define DRV_EHCI_UTILS_MALLOC32_H
-
-#include <as.h>
-#include <ddi.h>
-#include <errno.h>
-#include <stdlib.h>
-#include <sys/types.h>
-
-/* Generic TDs and EDs require 16byte alignment,
- * Isochronous TD require 32byte alignment,
- * buffers do not have to be aligned.
- */
-#define EHCI_ALIGN   32
-
-#define EHCI_REQUIRED_PAGE_SIZE   4096
-
-/** Get physical address translation
- *
- * @param[in] addr Virtual address to translate
- * @return Physical address if exists, NULL otherwise.
- */
-static inline uintptr_t addr_to_phys(const void *addr)
-{
-	uintptr_t result;
-	int ret = as_get_physical_mapping(addr, &result);
-	
-	if (ret != EOK)
-		return 0;
-	
-	return result;
-}
-
-/** Create 4KB page mapping
- *
- * @return Address of the mapped page, NULL on failure.
- */
-static inline void *get_page(void)
-{
-	uintptr_t phys;
-	void *address = AS_AREA_ANY;
-
-	const int ret = dmamem_map_anonymous(EHCI_REQUIRED_PAGE_SIZE,
-	    DMAMEM_4GiB, AS_AREA_READ | AS_AREA_WRITE, 0, &phys,
-	    &address);
-
-	return ((ret == EOK) ? address : NULL);
-}
-
-static inline void return_page(void *page)
-{
-	dmamem_unmap_anonymous(page);
-}
-
-/** Physical mallocator simulator
- *
- * @param[in] size Size of the required memory space
- * @return Address of the aligned and big enough memory place, NULL on failure.
- */
-static inline void * malloc32(size_t size)
-{
-	assert(size < PAGE_SIZE);
-	return get_page();
-}
-
-/** Physical mallocator simulator
- *
- * @param[in] addr Address of the place allocated by malloc32
- */
-static inline void free32(void *addr)
-{
-	return_page(addr);
-}
-
-#endif
-/**
- * @}
- */
Index: uspace/lib/usbhost/include/usb/host/utils/malloc32.h
===================================================================
--- uspace/lib/usbhost/include/usb/host/utils/malloc32.h	(revision 45cbf897eae041f9fcdb375736ef47f65e11f98b)
+++ uspace/lib/usbhost/include/usb/host/utils/malloc32.h	(revision 45cbf897eae041f9fcdb375736ef47f65e11f98b)
@@ -0,0 +1,119 @@
+/*
+ * Copyright (c) 2013 Jan Vesely
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+/** @addtogroup drvusbehci
+ * @{
+ */
+/** @file
+ * @brief EHCI driver
+ */
+#ifndef DRV_EHCI_UTILS_MALLOC32_H
+#define DRV_EHCI_UTILS_MALLOC32_H
+
+#include <align.h>
+#include <as.h>
+#include <ddi.h>
+#include <errno.h>
+#include <stdlib.h>
+#include <sys/types.h>
+
+/* Generic TDs and EDs require 16byte alignment,
+ * Isochronous TD require 32byte alignment,
+ * buffers do not have to be aligned.
+ */
+#define EHCI_ALIGN   32
+
+#define EHCI_REQUIRED_PAGE_SIZE   4096
+
+/** Get physical address translation
+ *
+ * @param[in] addr Virtual address to translate
+ * @return Physical address if exists, NULL otherwise.
+ */
+static inline uintptr_t addr_to_phys(const void *addr)
+{
+	uintptr_t result;
+	int ret = as_get_physical_mapping(addr, &result);
+	
+	if (ret != EOK)
+		return 0;
+	
+	return result;
+}
+
+/** Physical mallocator simulator
+ *
+ * @param[in] size Size of the required memory space
+ * @return Address of the aligned and big enough memory place, NULL on failure.
+ */
+static inline void * malloc32(size_t size)
+{
+	uintptr_t phys;
+	void *address = AS_AREA_ANY;
+	size_t real_size = ALIGN_UP(size, PAGE_SIZE);
+
+	const int ret = dmamem_map_anonymous(real_size,
+	    DMAMEM_4GiB, AS_AREA_READ | AS_AREA_WRITE, 0, &phys,
+	    &address);
+
+	if (ret == EOK) {
+		/* Poison, accessing it should be enough to make sure
+		 * the location is mapped, but poison works better */
+		memset(address, 0x5, real_size);
+		return address;
+	}
+	return NULL;
+}
+
+/** Physical mallocator simulator
+ *
+ * @param[in] addr Address of the place allocated by malloc32
+ */
+static inline void free32(void *addr)
+{
+	dmamem_unmap_anonymous(addr);
+}
+
+/** Create 4KB page mapping
+ *
+ * @return Address of the mapped page, NULL on failure.
+ */
+static inline void *get_page()
+{
+	return malloc32(PAGE_SIZE);
+}
+
+static inline void return_page(void *page)
+{
+	free32(page);
+}
+
+
+#endif
+/**
+ * @}
+ */
